#requireadmin

; Masque l'icone dans le Systray ----------------------------------------------- ;
#NoTrayIcon                                                                      ;
Break (0)                                                                        ;
; ------------------------------------------------------------------------------ ;


#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <WindowsConstants.au3>
#Include <String.au3>
#Include <Array.au3>
#include <StaticConstants.au3>
#include <Constants.au3>
#include <GUIListBox.au3>
#include <GuiMenu.au3>


$gray = 0x888888
$green = 0x00cc00
$red = 0xff0000


$title = "Package Deployer"
$version = "1.0"
$w = 550
$h = 600
$regPath = "HKLM\Software\" & $title
$fichier = ""



Dim $fenetre, $tab, $mainTab,	$allHosts, $OKHosts, $WaitHosts, $errorHosts, $nameLabel, $projectName, $nbMachines
Dim $filemenu, $help
Dim $allHostsList, $OKHostsList, $WaitHostsList, $errorHostsList
Dim $addAllHostsButton, $delAllHostsButton, $importAllHostsButton, $delOKHostsButton, $delWaitHostsButton, $delErrorHostsButton
Dim $changeName, $changeExe, $changeArgs, $changeUsername, $changePassword
Dim $nameText, $exeText, $argsText, $usernameTexte, $passwTexte, $usernameName, $exeName, $passwordName
Dim $allHostsTab[1], $OKHostsTab[1], $WaitHostsTab[1], $errorHostsTab[1]
Dim $graph, $nbWaitHostsLabel, $nbOKHostsLabel, $nbErrorHostsLabel, $nbAllHostsLabel
Dim $loaded
Dim $currentHost, $runButton, $deploying, $pid, $beginTime, $psexecLocation
Dim $exportAllHostsButton, $exportOKHostsButton, $exportWaitHostsButton, $exportErrorHostsButton
Dim $cancelOKHostsButton, $cancelErrorHostsButton
Dim $recentTab[1], $recentMenu[1], $recents


; Liste des caractres interdits
Dim $forbiddenChars[1]
_ArrayAdd ( $forbiddenChars, "/")
; _ArrayAdd ( $forbiddenChars, "\")
_ArrayAdd ( $forbiddenChars, '"')
_ArrayAdd ( $forbiddenChars, "*")
_ArrayAdd ( $forbiddenChars, '?')
_ArrayAdd ( $forbiddenChars, '<')
_ArrayAdd ( $forbiddenChars, '>')
_ArrayAdd ( $forbiddenChars, '|')
_ArrayAdd ( $forbiddenChars, ':')
_ArrayAdd ( $forbiddenChars, '=')
_ArrayDelete($forbiddenChars, 0 )

$forbiddenCharDetected = "La modification n'a pas t prise en compte car les caractres  suivants sont interdits :" & chr(13)
For $i = 0 To UBound($forbiddenChars) - 1
	$forbiddenCharDetected = $forbiddenCharDetected & $forbiddenChars[$i] & " "
Next


If $CmdLine[0] > 0 Then
	If FileExists( $CmdLine[1] ) Then $fichier = $CmdLine[1]
	If $CmdLine[0] == 2 Then
		If $CmdLine[2] == "-deploy" Then
			$deploying = 1
		EndIf
	EndIf
EndIf



If NOT FileExists(@ScriptDir & "\logo.jpg") Then FileInstall("logo.jpg", @ScriptDir & "\logo.jpg", 1 )
If NOT FileExists(@ScriptDir & "\icones.icl") Then FileInstall("icones.icl", @ScriptDir & "\icones.icl", 1 )



If $deploying == 1 Then

	Load()
	LoadHosts()

	If $psexecLocation == "" Then
		If NOT Prefs() Then Exit
	EndIf

	If NOT FileExists($psexecLocation & "\psexec.exe") Then
		MsgBox(16, "Erreur", "Impossible de trouver " & $psexecLocation & "\psexec.exe" )
		Exit
	EndIf


	; Lecture du fichier
	; $var = IniReadSection($fichier, "HOSTS")
	; If @error Then Exit

	; Cration de la barre de progression
	ProgressOn("Dploiement en cours", "Dploiement en cours ...", "", 0, 0, 16)
	
	$lf = FileOpen( StringReplace($fichier, ".pkgd" , ".log") , 1 )

	FileWriteLine($lf, "-------------------------------------------------")
	FileWriteLine($lf, "Dbut du dploiement le " & @MDAY & "/" & @MON & "/" & @YEAR & "  " & @hour & ":" & @min & ":" & @sec )
	FileWriteLine($lf, "-------------------------------------------------")


	For $i = 0 To UBound($waitHostsTab) - 1
		$host = $waitHostsTab[$i]

		$percent = Round($i * 100 / UBound($waitHostsTab), 0)
		ProgressSet( $percent , $host & " ( " & $i & " / " & UBound($waitHostsTab) & ")" )

		If Ping($host, 1000) > 0 Then
			
			Local $cmd = Run (@ComSpec & " /c psexec.exe \\" & $host & " -u " & $usernameName & " -p " & $passwordName & " -c -d -f -i -n 10 " & $exeName, $psexecLocation, "", $STDERR_CHILD + $STDOUT_CHILD )
			
			
			; Rsultat vide pour l'instant
			$res = ""

			; Rcupration du texte de la fentre DOS dans $res
			While 1
			    $res = $res & StderrRead($cmd)
			    If @error Then ExitLoop
			Wend
			
			If StringInStr($res, "with error code 0") OR StringInStr($res, "with process ID") Then
				IniWrite($fichier, "HOSTS", $host, "OK" )
				WriteLog($lf, $host, "OK")
			Else
				IniWrite($fichier, "HOSTS", $host, "NOK" )
				WriteLog($lf, $host, "ERREUR")
			EndIf

		Else
			WriteLog($lf, $host, "PAS DE REPONSE")
		EndIf


	Next

	
	FileWriteLine($lf, "Fin du dploiement le " & @MDAY & "/" & @MON & "/" & @YEAR & "  " & @hour & ":" & @min & ":" & @sec )
	FileWriteLine($lf, "")
	FileWriteLine($lf, "")

	FileClose($lf)



	Exit










Else
	While 1
		Fenetre()
	WEnd
EndIf

Func Fenetre()
	$deploying = 0
	$currentHost = 0


	$fenetre = GUICreate( $title  , $w , $h )
	; Cration du Menu
	$filemenu = GUICtrlCreateMenu("&Fichier")
     $new = GUICtrlCreateMenuItem("&Nouveau projet", $filemenu)
	$open = GUICtrlCreateMenuItem("&Ouvrir", $filemenu)

	GUICtrlCreateMenuItem("", $filemenu )
	$psexec = GUICtrlCreateMenuItem("&PsExec...", $filemenu)
	GUICtrlCreateMenuItem("", $filemenu )
	$exit = GUICtrlCreateMenuItem("&Quitter", $filemenu)

	$help = GUICtrlCreateMenu("?")
     $about = GUICtrlCreateMenuItem("A propos de " & $title, $help)



	If $fichier <> "" Then

		Load()
		LoadHosts()
		majLists()
		majGraph()

	EndIf




	GUISetState()

	; Run the GUI until the dialog is closed
	While 1
		If $loaded Then
			$loaded = 0
			GUIDelete ($fenetre)
			ExitLoop
		EndIf

		$msg = GUIGetMsg()

		If $msg = $GUI_EVENT_CLOSE OR $msg = $exit Then Exit
		If $msg = $open Then Open()
		If $msg = $new Then New()
		If $msg = $about Then About()
		If $msg = $psexec Then Prefs()


		If $fichier <> "" Then
			If $msg = $delAllHostsButton Then move($allHostslist, $allHosts)
			If $msg = $delOKHostsButton Then move($OKHostslist, $OKHosts)
			If $msg = $delWaitHostsButton Then move($waitHostslist, $waitHosts)
			If $msg = $delErrorHostsButton Then move($errorHostslist, $errorHosts)

			If $msg == $cancelOKHostsButton Then move($OKHostsList, $OKHosts , 1)
			If $msg == $cancelErrorHostsButton Then move($errorHostsList, $errorHosts , 1)

			If $msg = $addAllHostsButton Then addHost()
			If $msg = $importAllHostsButton Then importFile()
			
			If $msg == $changeName Then change("NAME" )
			If $msg == $changeExe Then change("PACKAGE")

			If $msg == $changeArgs Then change("ARGS")
			If $msg == $changeUsername Then change("USERNAME" )
			If $msg == $changePassword Then change("PASSWORD" )

			If $msg == $exportAllHostsButton OR $msg == $exportOKHostsButton OR $msg == $exportWaitHostsButton OR $msg == $exportErrorHostsButton Then ExportList($msg)


			
			If $msg == $runButton Then
				Local $error = 0
				If $deploying == 0 Then
					If $exeName == ""  Then
						$error = 1
						MsgBox(16, "Erreur", "Vous devez choisir le package  dployer")
					ElseIf $usernameName == "" OR $passwordName == "" Then
						$error = 1
						MsgBox(16, "Erreur", "Vous devez entrer un nom d'utilisateur et un mot de passe pour la connexion  distance")
					EndIf
										
					If $error == 0 Then
						$deploying = 1
						$beginTime = TimerInit()
						lockWindow(1)
						startDeploy()
					EndIf
				ElseIf $deploying == 1 Then
					lockWindow(0)
					$deploying = 0
					stopDeploy()
				EndIf
			EndIf


			If $deploying == 1 Then
				If NOT ProcessExists($pid) Then
					Sleep(500)
					lockWindow(0)
				EndIF

				If TimerDiff($beginTime) > 1000 Then
					LoadHosts()
					majGraph()
					$beginTime = TimerInit()
				EndIf
			EndIf


		EndIf


	WEnd

EndFunc



Func Load()
	If $fichier <> "" Then
		GUICtrlDelete($tab)
		GUICtrlDelete($mainTab)
		GUICtrlDelete($allHostsList)
		GUICtrlDelete($OKHostsList)
		GUICtrlDelete($WaitHostsList)
		GUICtrlDelete($errorHostsList)
		GUICtrlDelete($nameLabel)

		$projectName = IniRead($fichier, "PROJET", "NAME", "")
		$exeName = IniRead($fichier, "PROJET", "PACKAGE", "")
		$argsName = IniRead($fichier, "PROJET", "ARGS", "")
		$usernameName = IniRead($fichier, "PROJET", "USERNAME", "")
		$passwordName = _StringEncrypt( 0 , IniRead($fichier, "PROJET", "PASSWORD", ""), "robert" )
		$psexecLocation = RegRead($regPath, "PsExecLocation" )


		WinSetTitle ( $title , "", $title & " - " & $projectName )

		$tab = GUICtrlCreateTab(10, 10, $w - 20, 20)
		
		; Onglet Gnral -------------------------------------------------------------
		$mainTab = GUICtrlCreateTabItem("Gnral" )

		$graph = GUICtrlCreateGraphic( 40, 250, 170, 170 )
		$waitHostsLabel = GUICtrlCreateLabel( "Machines en attente : ", 20, 420, 200, 20 )
		$nbWaitHostsLabel =  GUICtrlCreateLabel( "", 160, 420, 200, 20 )
		GUICtrlSetColor ($waitHostsLabel, $gray)
		GUICtrlSetColor ($nbWaitHostsLabel, $gray)

		$OKHostsLabel = GUICtrlCreateLabel( "Machines dj dployes : ", 20, 440, 200, 20 )
		$nbOKHostsLabel =  GUICtrlCreateLabel( "", 160, 440, 200, 20 )
		GUICtrlSetColor ($OKHostsLabel, $green)
		GUICtrlSetColor ($nbOKHostsLabel, $green)

		$errorHostsLabel = GUICtrlCreateLabel( "Machines en erreur : ", 20, 460, 200, 20 )
		$nbErrorHostsLabel =  GUICtrlCreateLabel( "", 160, 460, 200, 20 )
		GUICtrlSetColor ($errorHostsLabel, $red)
		GUICtrlSetColor ($nbErrorHostsLabel, $red)

		$allHostsLabel =  GUICtrlCreateLabel( "Total :", 20, 480, 200, 20 )
		$nbAllHostsLabel = GUICtrlCreateLabel( "", 160, 480, 200, 20 )



		GUICtrlCreateGroup ( "Projet", 20, 40, 420, 100 )
		$nameLabel = GUICtrlCreateLabel("Nom du projet : ", 40, 60, 150, 20)
		$nameText = GUICtrlCreateInput($projectName, 190, 55, 200, 20)
		GUICtrlSetstate ($nameText , $GUI_DISABLE )
		$changeName = GUICtrlCreateButton ("...", 400, 55, 20, 20 )
		
		$exeLabel = GUICtrlCreateLabel("Package : ", 40, 85, 150, 20)
		$exeText = GUICtrlCreateInput($exeName , 190, 80, 200, 20)
		GUICtrlSetstate ($exeText , $GUI_DISABLE )
		$changeExe = GUICtrlCreateButton ("...", 400, 80, 20, 20 )

		$argsLabel = GUICtrlCreateLabel("Arguments : ", 40, 110, 150, 20)
		$argsText = GUICtrlCreateInput($argsName , 190, 105, 200, 20)
		GUICtrlSetstate ($argsText , $GUI_DISABLE )
		$changeArgs = GUICtrlCreateButton ("...", 400, 105, 20, 20 )

		GUICtrlCreateGroup ( "Compte", 20, 150, 420, 75 )
		$usernameLabel = GUICtrlCreateLabel("Nom d'utilisateur : ", 40, 170, 150, 20)
		$usernameTexte = GUICtrlCreateInput($usernameName, 190, 165, 200, 20)
		GUICtrlSetstate ($usernameTexte , $GUI_DISABLE )
		$changeUsername = GUICtrlCreateButton ("...", 400, 165, 20, 20 )

		$passwLabel = GUICtrlCreateLabel("Mot de passe : ", 40, 195, 150, 20)
		$passwordTXT = ""
		For $i = 1 To StringLen($passwordName)
			$passwordTXT &= chr(149)
		Next

		$passwTexte = GUICtrlCreateInput($passwordTXT, 190, 190, 200, 20)
		GUICtrlSetstate ($passwTexte , $GUI_DISABLE )
		$changePassword = GUICtrlCreateButton ("...", 400, 190, 20, 20 )

		; Bouton run
		$runButton = GUICtrlCreateButton ("2", 400, 250, 40, 40,$BS_ICON)
		GUICtrlSetImage ($runButton, @ScriptDir & "\icones.icl", 1)
		GUICtrlSetTip(-1,"Lancer le dploiement")
		GUICtrlSetCursor(-1, 0)





		; Onglet Toutes les machines -------------------------------------------------

		$allHosts = GUICtrlCreateTabItem("Toutes les machines" )
		$allHostsList = GUICtrlCreateList("", 20, 40, 200, 500, BitOR($LBS_STANDARD, $LBS_EXTENDEDSEL) )
    
		; Bouton Ajouter
		$addAllHostsButton = GUICtrlCreateButton ("2", 230,50,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 3)
		GUICtrlSetTip(-1,"Ajouter")
		GUICtrlSetCursor(-1, 0)
		
		; Bouton supprimer
		$delAllHostsButton = GUICtrlCreateButton ("2", 230,100,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 4)
		GUICtrlSetTip(-1,"Supprimer")
		GUICtrlSetCursor(-1, 0)

		; Bouton supprimer
		$importAllHostsButton = GUICtrlCreateButton ("2", 230,150,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 5)
		GUICtrlSetTip(-1,"Importer depuis un fichier")
		GUICtrlSetCursor(-1, 0)

		$exportAllHostsButton = GUICtrlCreateButton ("2", 230,500,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 6)
		GUICtrlSetTip(-1,"Exporter la liste dans un fichier")
		GUICtrlSetCursor(-1, 0)





		; Onglet Machines dj dployes ---------------------------------------------

		$OKHosts = GUICtrlCreateTabItem("Machines dj dployes")
		$OKHostsList = GUICtrlCreateList("", 20, 40, 200, 500 , BitOR($LBS_STANDARD, $LBS_EXTENDEDSEL) )

		; Bouton supprimer
		$delOKHostsButton = GUICtrlCreateButton ("2", 230,50,40,40,$BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 4)
		GUICtrlSetTip(-1,"Supprimer")
		GUICtrlSetCursor(-1, 0)

		$cancelOKHostsButton = GUICtrlCreateButton ("2", 230,100,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 7)
		GUICtrlSetTip(-1,"Mettre en attente les machines slectionnes")
		GUICtrlSetCursor(-1, 0)

		$exportOKHostsButton = GUICtrlCreateButton ("2", 230,500,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 6)
		GUICtrlSetTip(-1,"Exporter la liste dans un fichier")
		GUICtrlSetCursor(-1, 0)






		; Onglet en attente ----------------------------------------------------------

		$WaitHosts = GUICtrlCreateTabItem("Machines en attente")
		$waitHostsList = GUICtrlCreateList("", 20, 40, 200, 500 , BitOR($LBS_STANDARD, $LBS_EXTENDEDSEL) )

		; Bouton supprimer
		$delWaitHostsButton = GUICtrlCreateButton ("2", 230,50,40,40,$BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 4)
		GUICtrlSetTip(-1,"Supprimer")
		GUICtrlSetCursor(-1, 0)

		$exportWaitHostsButton = GUICtrlCreateButton ("2", 230,500,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 6)
		GUICtrlSetTip(-1,"Exporter la liste dans un fichier")
		GUICtrlSetCursor(-1, 0)


		; Onglet en erreur -----------------------------------------------------------

		$errorHosts = GUICtrlCreateTabItem("Machines en erreur")
		$errorHostsList = GUICtrlCreateList("", 20, 40, 200, 500 , BitOR($LBS_STANDARD, $LBS_EXTENDEDSEL) )
		$delErrorHostsButton = GUICtrlCreateButton ("2", 230,50,40,40,$BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 4)
		GUICtrlSetTip(-1,"Supprimer")
		GUICtrlSetCursor(-1, 0)

		$cancelErrorHostsButton = GUICtrlCreateButton ("2", 230,100,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 7)
		GUICtrlSetTip(-1,"Mettre en attente les machines slectionnes")
		GUICtrlSetCursor(-1, 0)

		$exportErrorHostsButton = GUICtrlCreateButton ("2", 230,500,40,40, $BS_ICON)
		GUICtrlSetImage (-1, @ScriptDir & "\icones.icl", 6)
		GUICtrlSetTip(-1,"Exporter la liste dans un fichier")
		GUICtrlSetCursor(-1, 0)


		GUICtrlCreateTabItem("")
		; GUICtrlSetState ($tab, $GUI_DISABLE)

		GUICtrlCreatePic(@ScriptDir & "\logo.jpg", 300, 440, 221, 98)

		GUICtrlSetState ( $mainTab, $GUI_SHOW )

	

	EndIf


EndFunc



Func Open()
	$fichier = FileOpenDialog ( "Ouvrir un projet", @ScriptDir, "Fichier " & $title & "(*.pkgd)", 1 )
	If $fichier <> "" Then $loaded = 1
EndFunc




Func New()
	$projectName = InputBox ( $title & " - Nouveau projet", "Entrez le nom du projet" )
	If $projectName == "" Then Return 0
	If NOT verifChars($projectName) Then
		MsgBox(16, "Erreur", $forbiddenCharDetected )
		Return 0
	EndIf


	$fichier = FileSaveDialog ($title & " - Fichier projet", @ScriptDir, $title & "(*.pkgd)", 18, $projectName & ".pkgd" )
	If $fichier == "" Then Return 0

	; Vide tout le fichier (pour le cas o on a choisi d'craser le fichier)
	IniDelete($fichier, "PROJET")
	IniDelete($fichier, "HOSTS")

	IniWrite($fichier, "PROJET", "NAME", $projectName)
	IniWrite($fichier, "HOSTS", "vide", "")
	IniDelete($fichier, "HOSTS", "vide")
	$loaded = 1


EndFunc



Func LoadHosts()
	
	; On redclare les tableaux pour les dtruire
	Dim $allHostsTab[1], $OKHostsTab[1], $WaitHostsTab[1], $errorHostsTab[1]

	
	$var = IniReadSection($fichier, "HOSTS")
	If @error Then Return 0

	For $i = 1 To $var[0][0]
		_ArrayAdd( $allHostsTab, $var[$i][0])
		
		If $var[$i][1] == "OK" Then
			_ArrayAdd( $OKHostsTab, $var[$i][0])
		Elseif $var[$i][1] == "NOK" Then
			_ArrayAdd( $errorHostsTab, $var[$i][0])
		Elseif $var[$i][1] == "" Then
			_ArrayAdd( $waitHostsTab, $var[$i][0])
		EndIf
	Next

	_ArrayDelete($allHostsTab, 0)
	_ArrayDelete($OKHostsTab, 0)
	_ArrayDelete($waitHostsTab, 0)
	_ArrayDelete($errorHostsTab, 0)

	_ArraySort($allHostsTab)
	_ArraySort($OKHostsTab)
	_ArraySort($waitHostsTab)
	_ArraySort($errorHostsTab)


EndFunc


Func move($list, $tab, $action = 0)

	$aItems = _GUICtrlListBox_GetSelItemsText($list)

	If $aItems[0] == 0 Then Return 0
	If $action == 0 Then $texte = "Etes-vous sr de vouloir supprimer les machines slectionnes ?"
	If $action == 1 Then $texte = "Etes-vous sr de vouloir placer les machines slectionnes en attente ?"

	If MsgBox ( 52, "Attention", $texte ) == 6 Then
		For $iI = 1 To $aItems[0]
			If $action == 0 Then IniDelete($fichier, "HOSTS", $aItems[$iI] )
			If $action == 1 Then IniWrite($fichier, "HOSTS", $aItems[$iI] , "")
		Next

		Load()
		LoadHosts()
		majLists()
		majGraph()
		GUICtrlSetState ( $tab, $GUI_SHOW )
	EndIf
EndFunc


Func addHost()
	$newHost = InputBox ( "Ajout d'une machine", "Entrez l'adresse IP ou le nom de machine" , "192.168." )
	If $newHost == "" Then Return 1

	$exists = IniRead( $fichier, "HOSTS", $newHost, "vide" )
	If $exists <> "vide" Then
		 $status = "inconnu"
		If $exists == "" Then $status = "En attente"
		If $exists == "OK" Then $status = "Dj dploye"
		If $exists == "NOK" Then $status = "En erreur"

		MsgBox(16, "Ajout impossible", "La machine " & $newHost & " est dj prsente dans le projet (Statut : " & $status & ")"  )
	Else
		IniWrite($fichier, "HOSTS", $newHost, "" )
		Load()
		LoadHosts()
		majLists()
		majGraph()
		GUICtrlSetState ( $allHosts, $GUI_SHOW )
	EndIf
EndFunc


Func importFile()
	$file2import = FileOpenDialog ( "Importer des machines", _FileGetPath($fichier), "Fichiers texte (*.txt)", 3 )
	If $file2import == "" Then Return 1

	$f = FileOpen($file2import, 0)

	If $f = -1 Then
		MsgBox(16, "Erreur", "Impossible d'ouvrir le fichier")
		Return 1
	EndIf

	While 1
		$line = FileReadLine($f)
		If @error = -1 Then ExitLoop
		$exists = IniRead( $fichier, "HOSTS", $line, "vide" )
		If $exists == "vide" Then
			IniWrite($fichier, "HOSTS", $line, "" )
		EndIf
	Wend

	Load()
	LoadHosts()
	majLists()
	majGraph()

	GUICtrlSetState ( $allHosts, $GUI_SHOW )

	FileClose($f)

EndFunc


Func change($what )
	$type = ""
	$currentValue = IniRead($fichier, "PROJET", $what, "")
	
	If $what == "NAME" OR $what == "ARGS" OR $what == "USERNAME" OR $what == "PASSWORD" Then
		If $what == "NAME" Then $text = "Nom du projet"
		If $what == "ARGS" Then $text = "Arguments pour l'excutation du programme"
		If $what == "USERNAME" Then $text = "Compte utilisateur distant"
		If $what == "PASSWORD" Then
			$text = "Mot de passe pour le compte utilisateur distant"
			$type = "*"
			$currentValue = _StringEncrypt( 0 , $currentValue, "robert" )
		EndIf

		$newValue = InputBox( $title, $text, $currentValue , $type )

	ElseIf $what == "PACKAGE" Then
		$newValue = FileOpenDialog ("Choisissez le package  dployer", "c:\util", "Programmes (*.exe)", 3 )
	EndIf

	If $newValue == "" AND $what <> "ARGS" Then Return 1
	If $type == "*" Then $newValue = _StringEncrypt( 1 , $newValue, "robert" )

	If $what <> "PACKAGE" AND $what <> "ARGS" Then
		If NOT verifChars($newValue) Then
			MsgBox(16, "Erreur", $forbiddenCharDetected )
			Return 1
		EndIf
	EndIf

	IniWrite($fichier, "PROJET", $what, $newValue)
	Load()
	LoadHosts()
	majLists()
	majGraph()



	
EndFUnc


Func verifChars($chaine)
	For $i = 0 To UBound ($forbiddenChars) - 1
		If StringInStr($chaine, $forbiddenChars[$i] ) Then
			Return 0
		EndIf
	Next
	Return 1
EndFunc



Func majGraph()
	; Mise  jour du graphique -------------------------------------



	$nbMachines = UBound($allHostsTab)
	$nbOK = UBound($OKHostsTab)
	$nbError = UBound($errorHostsTab)
	$nbWait = $nbMachines - $nbOK - $nbError


	$angle1 = Round($nbOK * 360 / $nbMachines, 0)
	$angle2 = Round($nbWait * 360 / $nbMachines, 0)
	$angle3 = 360 - $angle1 - $angle2

	If $nbMachines == 1 Then
		If $allHostsTab[0] == "" Then
			$angle1 = 360
			$angle2 = 0
			$angle3 = 0
			$nbOK = 0
			$nbError = 0
			$nbWait = 0
			$nbMachines = 0
		EndIf
	EndIf

	$percentOKHosts = ""
	$percentWaitHosts = ""
	$percentErrorHosts = ""

	If $nbMachines <> 0 Then
		$percentWaitHosts = Round($nbWait * 100 / $nbMachines, 0 )
		$percentOKHosts = Round($nbOK * 100 / $nbMachines, 0 )
		$percentErrorHosts = Round($nbError * 100 / $nbMachines, 0 )
	
		$percentWaitHosts = " (" & $percentWaitHosts & "%)"
		$percentOKHosts = " (" & $percentOKHosts & "%)"
		$percentErrorHosts = " (" & $percentErrorHosts & "%)"

		GUICtrlSetGraphic($graph, $GUI_GR_COLOR, 0, $green)
		GUICtrlSetGraphic($graph, $GUI_GR_PIE, 60, 80, 80, 0, $angle1)

		GUICtrlSetGraphic($graph, $GUI_GR_COLOR, 0, $gray)
		GUICtrlSetGraphic($graph, $GUI_GR_PIE, 60, 80, 80, $angle1, $angle2)
		
		GUICtrlSetGraphic($graph, $GUI_GR_COLOR, 0, $red)
		GUICtrlSetGraphic($graph, $GUI_GR_PIE, 60, 80, 80, $angle1 + $angle2, $angle3)

		GUICtrlSetData($nbWaitHostsLabel, $nbWait & $percentWaitHosts)
		GUICtrlSetData($nbOKHostsLabel, $nbOK & $percentOKHosts)
		GUICtrlSetData($nbErrorHostsLabel, $nbError & $percentErrorHosts )
		GUICtrlSetData($nbAllHostsLabel, $nbMachines )

		GUICtrlSetGraphic($graph, $GUI_GR_REFRESH )

	Else
		GUICtrlSetGraphic($graph, $GUI_GR_COLOR, 0, 0xffffff)
		GUICtrlSetGraphic($graph, $GUI_GR_PIE, 60, 80, 80, 0, 360)
	EndIf

	
	; -----------------------------------------------





EndFunc


Func majLists()
	; On vide toutes les listes
	GUICtrlSetData($allHostsList, "")
	GUICtrlSetData($OKHostsList, "")
	GUICtrlSetData($waitHostsList, "")
	GUICtrlSetData($errorHostsList, "")

	_GUICtrlListBox_BeginUpdate($allHostsList)
	For $i = 0 To UBound ( $allHostsTab) - 1
		_GUICtrlListBox_AddString ($allHostsList, $allHostsTab[$i] )
	Next
	_GUICtrlListBox_EndUpdate($allHostsList)


	_GUICtrlListBox_BeginUpdate($OKHostsList)
	For $i = 0 To UBound ( $OKHostsTab) - 1
		_GUICtrlListBox_AddString ($OKHostsList, $OKHostsTab[$i] )
	Next
	_GUICtrlListBox_EndUpdate($OKHostsList)


	_GUICtrlListBox_BeginUpdate($waitHostsList)
	For $i = 0 To UBound ( $waitHostsTab) - 1
		_GUICtrlListBox_AddString ($waitHostsList, $waitHostsTab[$i] )
	Next
	_GUICtrlListBox_EndUpdate($waitHostsList)



	_GUICtrlListBox_BeginUpdate($errorHostsList)
	For $i = 0 To UBound ( $errorHostsTab) - 1
		_GUICtrlListBox_AddString ($errorHostsList, $errorHostsTab[$i] )
	Next
	_GUICtrlListBox_EndUpdate($errorHostsList)


EndFunc


Func startDeploy()
	$pid = Run(@ScriptFullPath & ' "' & $fichier & '" ' & "-deploy", @ScriptDir)
EndFunc

Func stopDeploy()
	ProcessClose($pid)
	ProcessClose("psexec.exe")

	$lf = FileOpen( StringReplace($fichier, ".pkgd" , ".log") , 1 )
	FileWriteLine($lf, "Interruption du dploiement le " & @MDAY & "/" & @MON & "/" & @YEAR & "  " & @hour & ":" & @min & ":" & @sec )
	FileClose($lf)

	majGraph()
EndFunc


Func lockWindow($state)
	loadHosts()
	majLists()
	majGraph()

	if $state == 1 Then
		; Verrouiller la fenetre
		$deploying = 1
		GUICtrlSetstate($graph, $GUI_HIDE)
		GUICtrlSetImage ($runButton, @ScriptDir & "\icones.icl", 2)
		GUICtrlSetTip($runButton ,"Arrter le dploiement")
		GUICtrlSetState($tab, $GUI_DISABLE)
		GUICtrlSetState($changeName, $GUI_DISABLE)
		GUICtrlSetState($changeExe, $GUI_DISABLE)
		GUICtrlSetState($changeArgs, $GUI_DISABLE)
		GUICtrlSetState($changeUsername, $GUI_DISABLE)
		GUICtrlSetState($changePassword, $GUI_DISABLE)
		GUICtrlSetState($tab, $GUI_DISABLE)

		GUICtrlSetState($filemenu, $GUI_DISABLE)
		GUICtrlSetState($help, $GUI_DISABLE)

	Elseif $state == 0 Then
		$deploying = 0
		GUICtrlSetstate($graph, $GUI_SHOW)
		GUICtrlSetstate($graph, $GUI_ONTOP)
		GUICtrlSetImage ($runButton, @ScriptDir & "\icones.icl", 1)
		GUICtrlSetTip($runButton ,"Lancer le dploiement")
		GUICtrlSetState($tab, $GUI_ENABLE)
		GUICtrlSetState($changeName, $GUI_ENABLE)
		GUICtrlSetState($changeExe, $GUI_ENABLE)
		GUICtrlSetState($changeArgs, $GUI_ENABLE)
		GUICtrlSetState($changeUsername, $GUI_ENABLE)
		GUICtrlSetState($changePassword, $GUI_ENABLE)
		GUICtrlSetState($tab, $GUI_ENABLE)

		GUICtrlSetState($filemenu, $GUI_ENABLE)
		GUICtrlSetState($help, $GUI_ENABLE)
	EndIf
EndFunc


Func Debug($texte)
	MsgBox(0, "debug", $texte)
EndFunc


Func Prefs()
	$path = RegRead($regPath , "PsExecLocation")
	If $path == "" Then $path = @ScriptDir & "\psexec.exe"
	$path = _FileGetPath($path)

	$newPath = FileOpenDialog("Emplacement de PsExec.exe", $path, "Psexec (psexec.exe)", 3 , "psexec.exe" )
	If $newPath == "" Then Return 0

	$psexecLocation = _FileGetPath($newPath)
	RegWrite ( $regPath, "PsExecLocation", "REG_SZ", $psexecLocation )
	Return 1

EndFunc


Func _FileGetPath($file)
	; Eclate le chemin dans un tableau, avec comme sparateur le cartactre "\"
	$decoupe = StringSplit($file, "\")
	$path = $decoupe[1]
	For $i = 2 To UBound($decoupe) - 2
		$path = $path & "\" & $decoupe[$i]
	Next
	Return $path
EndFunc

Func ExportList($what)
	If $what == $exportAllHostsButton Then $exportTab = $allHostsTab
	If $what == $exportOKHostsButton Then $exportTab = $OKHostsTab
	If $what == $exportWaitHostsButton Then $exportTab = $WaitHostsTab
	If $what == $exportErrorHostsButton Then $exportTab = $errorHostsTab

	$fileSaveAs = FileSaveDialog("Export dans un fichier", _FileGetPath($fichier), "Fichier texte (*.txt)", 18 )
	If $fileSaveAs == "" Then Return 0

	$f = FileOpen($fileSaveAs, 1)
	If $f = -1 Then
	    MsgBox(16, "Erreur", "Impossible d'ouvrir le fichier " & $fileSaveAs)
	    Return 0
	EndIf

	For $i = 0 To UBound($exportTab) - 1
		FileWriteLine($f, $exportTab[$i] )
	Next

EndFunc





Func About()
	$larg = 221
	$haut = 210
	$pos = WinGetpos ( $title )

	
	$aboutWindow = GUICreate("A propos de " & $title, $larg, $haut, $pos[0] + ($w - $larg) / 2  , $pos[1] + ($h - $haut) / 2 , $WS_EX_WINDOWEDGE )
	GUICtrlCreatePic(@ScriptDir & "\logo.jpg", 0, 0, 221, 98)
	GUICtrlCreateLabel("Version : " & $version & chr(13) & "Jrme GUINCHARD - 2010", 10, 100, 221, 50)
	$ok = GuiCtrlCreateButton("OK", 30, 152, 150, 20 )

	GuiSetstate(@SW_DISABLE, $fenetre)
	GuiSetstate(@SW_SHOW, $aboutWindow)
	GUISwitch ( $aboutWindow)

	While 1
		$event = GUIGetMsg()
		If $event = $GUI_EVENT_CLOSE OR $event = $ok Then
			GuiDelete($aboutWindow)
			GUISwitch ( $fenetre)
			GuiSetstate(@SW_ENABLE, $fenetre)
			GuiSetstate(@SW_RESTORE, $fenetre)
			ExitLoop
		EndIf
	WEND

EndFunc



Func WriteLog($file, $host, $status)
	FileWriteLine($file, @hour & ":" & @min & ":" & @sec & chr(9) &  $host & chr(9) & $status )
EndFunc